#include <iostream>
#include <cstdlib>
#include <vector>
#include <stack>
#include <cmath>

using namespace std;


#define PRINT

/*
Constants :
q -> number of state
n -> neighborhood size
N=q^(n-1) -> number of state in the graph
m=q^n -> number of edges
*/

int q,n,N,options,iter;
int conf_size=200;

vector<int> automaton;
vector<int> config,aux;


#define int_pow(a,b) ((int)pow((double)a,(double)b))

void print_usage(){
  cout<<"Usage : ./crible RandSeed NumberOfIteration NumberOfState NeighborhoodSize Automaton"<<endl;
}


void print_control(){
}

void print_vector(vector<int>* vec){
  for (int i=0;i<(int)(*vec).size();i++){
    cerr<<(*vec)[i];
  }
  //	cerr<<endl;
}

int randbase(){
  double aux=(double) rand();
  return (int) aux;
}



bool string_eq(int l,char *a,char *b){
  for(int i=0;i<l;i++){
    if(!a[i]==b[i]){
      return false;
    }
  }
  return true;
}

int modulo(int n,int q){
  if(n%q<0)
    return q+n%q;
  else
    return n%q;
}

void create_config(){
  config.clear();
  for(int i=0;i<conf_size;i++){
    config.push_back(modulo(randbase(),q));
  }
}


void init(int a,int b){
  q=a;
  n=b;
  N=int_pow(a,b-1);
  create_config();
  aux.resize(conf_size);
}

void create_automaton(char **string){
  automaton.clear();
  int i=0;
  while((*string)[i]!='\0'){
    i++;
  }
  while(i>0){
    i--;
    automaton.push_back((int) (*string)[i]-'0');
  }
}

void get_opt(int argc, char **argv){
  if(argc<3)
    print_usage();
  else{
    for(int i=1;i<argc-3;i++){
      if(string_eq(7,argv[i],(char*) "--print") || string_eq(2,argv[i],(char*) "-p"))
        options+=1;
    }
    init(atoi(argv[argc-3]),atoi(argv[argc-2]));
    iter=(int) argv[argc-4];
    create_automaton(&(argv[argc-1]));
  }
}

int decimal(int base,int start,int end,vector<int> *vec){
  int res=0;
  for(int i=end;i>=start;i--){
    res=res*base+(*vec)[i];
  }
  return res;
}


void exec(vector<int> *input,vector<int> *output){
  int local=0;
  for(int i=(int) (*input).size()-1;i>=(int) (*input).size()-n;i--){
    local=local*q+(*input)[i];
  }
  for(int i=0;i<(int) (*input).size();i++){
    local=(local/q)+(*input)[i]*N;
    (*output)[i]=automaton[local];
  }
}

void swap(vector<int> **a,vector<int> **b){
  vector<int>** aux=a;
  *a=*b;
  *b=*aux;
}

bool test_id(vector<int> *input, vector<int> *output){
  bool res;
  int i=0;
  while( (*input)[i] == (*output)[i]  && i<(int) (*input).size()){
    i++;
  }
  res=(i==(int) (*input).size());
  return res;
}

bool test_shift(int decalage,vector<int> *input, vector<int> *output){
  int size=(int) (*input).size();
  int i=0;
  while( (*input)[i] == (*output)[modulo(i+decalage,size)]  && i<size){
    i++;
  }
  return (i!=size);
}


int main(int argc, char **argv){
  vector<int>* input;
  vector<int>* output;
  int j;
  srand((int) argv[1]);
  get_opt(argc,argv);
  //  cerr<<"Automate : ";
//  print_vector(&automaton);
//  cerr<<endl;
//  print_vector(&config);
//  cerr<<"    Config initiale"<<endl;
  input=&config;
  output=&aux;
  for(int i=0;i<20;i++){
    exec(input,output);
    exec(output,input);
  }
  // cerr<<"    Configs finale"<<endl;
  //
  j=0;
  while(j>-n && test_shift(j,input,output)){
    j--;
  }
  if(j!=-n)
    cerr<<"Identity/Shift-like..."<<endl;
  else{
  cerr<<"RAS "<<endl;
    cout<<argv[argc-1]<<endl;
  }
  return 0;
}
