#include <iostream>
#include <cstdlib>
#include <vector>
#include <algorithm>
#include <cmath>

using namespace std;

int q,v,N;

#define int_pow(a,b) ((int)pow((double)a,(double)b))
#define edge(v,x) (v*q+x)
#define dest(v,x) ((v*q+x)%N)
#define succ(v,x) (graph[v*q+x])
#define arrow(v,x) (N*v+x)
#define collapse(a,b) (a==b?0:N*a+b)

vector<int> automaton;

void identity(){
  automaton.resize(N);
  for(int i=0;i<N;i++){
    automaton[i]=(i/int_pow(q,(v/2-1)))%q;
  }
}

void mine(){
  for(int i=0;i<q;i++){
    automaton[i*27+19]=1;
    automaton[57+i]=0;
    automaton[i*27+21]=0;
    automaton[63+i]=1;
  }
}

void print_automaton(){
  for(int i=(int) automaton.size()-1;i>=0;i--){
    cout<<automaton[i];
  }
  cout<<endl;
}

int main(int argc, char **argv){
  q=atoi(argv[argc-2]);
  v=atoi(argv[argc-1]);
  N=int_pow(q,v);
  identity();
  print_automaton();
  mine();
  print_automaton();
  return 0;
}
